<template>
  <ModalVue v-show="isModalVisible" @closeModal="closeModal">
    <template v-slot:header>
      <template v-if="employeeData">Edit Employee</template>
      <template v-else>Create Employee</template>
    </template>

    <template v-slot:body>
      <form class="flex flex-col gap-6" @submit.prevent="submitForm">
        <div>
          <span class="text-gray-700">First name</span>
          <span class="ml-4 text-red-500" v-if="v$.formData.firstName.$error">
            {{ v$.formData.firstName.$errors[0].$message }}
          </span>
          <input
            type="text"
            class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
            placeholder="Employee's first name"
            v-model="formData.firstName"
          />
        </div>
        <div>
          <span class="text-gray-700">Last name</span>
          <span class="ml-4 text-red-500" v-if="v$.formData.lastName.$error">
            {{ v$.formData.lastName.$errors[0].$message }}
          </span>
          <input
            type="text"
            class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
            placeholder="Employee's last name"
            v-model="formData.lastName"
          />
        </div>
        <div class="flex justify-between">
          <div>
            <span class="text-gray-700">Number</span>
            <span class="ml-4 text-red-500" v-if="v$.formData.employeeNumber.$error">
              {{ v$.formData.employeeNumber.$errors[0].$message }}
            </span>
            <input
              type="number"
              class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
              placeholder="Employee's number"
              v-model="formData.employeeNumber"
            />
          </div>
          <div>
            <span class="text-gray-700">Extension</span>
            <span class="ml-4 text-red-500" v-if="v$.formData.extension.$error">
              {{ v$.formData.extension.$errors[0].$message }}
            </span>
            <input
              type="text"
              class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
              placeholder="Employee's extension"
              v-model="formData.extension"
            />
          </div>
        </div>
        <div>
          <span class="text-gray-700">Email</span>
          <span class="ml-4 text-red-500" v-if="v$.formData.email.$error">
            {{ v$.formData.email.$errors[0].$message }}
          </span>
          <input
            type="email"
            class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
            placeholder="Employee's email"
            v-model="formData.email"
          />
        </div>
        <div class="flex justify-between">
          <div>
            <span class="text-gray-700">Reports To</span>
            <select
              class="mt-1 w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
              v-model="formData.reportsTo"
            >
              <option disabled value="">Please select one</option>
              <option
                v-for="employee in employees"
                :value="employee.employeeNumber"
                :key="employee.employeeNumber"
              >
                {{ employee.firstName }} {{ employee.lastName }}
              </option>
            </select>
          </div>
          <div>
            <span class="text-gray-700">Office code</span>
            <span class="ml-4 text-red-500" v-if="v$.formData.officeCode.$error">
              {{ v$.formData.officeCode.$errors[0].$message }}
            </span>
            <input
              type="number"
              class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
              placeholder="Employee's office code"
              v-model="formData.officeCode"
            />
          </div>
        </div>
        <div>
          <span class="text-gray-700">Job Title</span>
          <span class="ml-4 text-red-500" v-if="v$.formData.jobTitle.$error">
            {{ v$.formData.jobTitle.$errors[0].$message }}
          </span>
          <input
            type="text"
            class="mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-gray-500 focus:ring focus:ring-gray-200 focus:ring-opacity-50"
            placeholder="Employee's job title"
            v-model="formData.jobTitle"
          />
        </div>
        <div class="flex flex-col items-center">
          <button
            type="submit"
            class="px-8 py-2 rounded-lg bg-gray-800 hover:bg-gray-500 text-white"
          >
            <template v-if="employeeData">Edit Employee</template>
            <template v-else>Create Employee</template>
          </button>
        </div>
      </form>
    </template>
  </ModalVue>
</template>

<script>
import ModalVue from './ModalVue.vue'
import useValidate from '@vuelidate/core'
import { required, email, minLength, numeric } from '@vuelidate/validators'
export default {
  components: {
    ModalVue
  },
  data() {
    return {
      v$: useValidate(),
      formData: {
        employeeNumber: null,
        firstName: '',
        lastName: '',
        extension: '',
        email: '',
        officeCode: null,
        reportsTo: '',
        jobTitle: ''
      }
    }
  },
  methods: {
    submitForm() {
      this.v$.$validate()
      if (!this.v$.$error) {
        if (this.employeeData) {
          this.editEmployee()
        } else {
          this.createEmployee()
        }
      }
    },
    createEmployee() {
      fetch('http://localhost:5000/employees', {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(this.formData)
      })
        .then((response) => response.json())
        .then(() => {
          this.closeModal()
          this.$emit('employeeCreatedEdited')
        })
        .catch((e) => console.log(e))
    },
    editEmployee() {
      fetch(`http://localhost:5000/employees/${this.currentEmployee}`, {
        method: 'PUT',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(this.formData)
      })
        .then((response) => response.json())
        .then(() => {
          this.closeModal()
          this.$emit('employeeCreatedEdited')
        })
        .catch((e) => console.log(e))
    },
    closeModal() {
      this.$emit('closeCreateEdit')
      this.$emit('clearEmployeeData')
      setTimeout(() => {
        this.formData = {
          employeeNumber: null,
          firstName: '',
          lastName: '',
          extension: '',
          email: '',
          officeCode: null,
          reportsTo: '',
          jobTitle: ''
        }
      }, 500)
    }
  },
  validations() {
    return {
      formData: {
        employeeNumber: { required, numeric },
        firstName: { required, minLength: minLength(3) },
        lastName: { required, minLength: minLength(3) },
        extension: { required },
        email: { required, email },
        officeCode: { required, numeric },
        reportsTo: { required, numeric },
        jobTitle: { required }
      }
    }
  },
  watch: {
    employeeData() {
      if (this.employeeData) {
        this.formData = this.employeeData
      }
    }
  },
  props: ['isModalVisible', 'employees', 'employeeData', 'currentEmployee'],
  emits: ['closeCreateEdit', 'employeeCreatedEdited', 'clearEmployeeData']
}
</script>
